// used to access design time types
export const DESIGN_TYPE = 'design:type';
// used to access design time types
export const DESIGN_PARAMTYPES = 'design:paramtypes';
// used to access design time types
export const DESIGN_RETURNTYPE = 'design:returntype';


// used to store types to be injected
export const POUCH_DEFINITION = 'loafer:pouch_definition';

// used to store types to be injected
export const POUCH_INJECT_DEFINITION = 'loafer:pouch_inject_definition';

export const POUCH_DEFAULT_QUALIFIER = Symbol('__QUALIFIER__');

export enum PouchScope {
  SINGLETON,
  PROTOTYPE,
}

export enum DecoratorType {
  CLASS,
  PROPERTY,
  PARAMETER,
  METHOD,
}

export type ClassConstructor<T> = {new(...args: any[]): T};
